package com.zhongshu.card.server.core.dao.devices.impl;

import com.github.microservice.components.data.mongo.mongo.helper.DBHelper;
import com.zhongshu.card.client.model.devices.deviceGroup.DeviceGroupToDeviceSearch;
import com.zhongshu.card.server.core.dao.BaseImpl;
import com.zhongshu.card.server.core.dao.devices.extend.DeviceGroupToDeviceDaoExtend;
import com.zhongshu.card.server.core.domain.devices.DeviceGroup;
import com.zhongshu.card.server.core.domain.devices.DeviceGroupToDevice;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author TRX
 * @CreateDate: 2023/4/12
 * @Version: 1.0
 */
public class DeviceGroupToDeviceDaoImpl extends BaseImpl implements DeviceGroupToDeviceDaoExtend {

    @Autowired
    private DBHelper dbHelper;

    @Override
    public Page<DeviceGroupToDevice> page(Pageable pageable, DeviceGroupToDeviceSearch param) {
        Criteria criteria = buildFilterCriteria(param);

        Sort sort = buildSort(param);
        Query query = Query.query(criteria);
        query.with(sort);
        return dbHelper.pages(query, pageable, DeviceGroupToDevice.class);
    }

    private Criteria buildFilterCriteria(DeviceGroupToDeviceSearch param) {
        Criteria criteria = buildCriteriaNotOid(param);

        if (StringUtils.isNotEmpty(param.getProjectOid())) {
            criteria.and("projectOid").is(param.getProjectOid());
        }

        if (StringUtils.isNotEmpty(param.getGroupId())) {
            criteria.and("deviceGroup").is(DeviceGroup.build(param.getGroupId()));
        }

        // 模糊搜索
        List<Criteria> criterias = new ArrayList<>();

        if (!CollectionUtils.isEmpty(criterias)) {
            criteria.andOperator(criterias.toArray(new Criteria[]{}));
        }
        return criteria;
    }

}
